/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this file is provided free of charge
  to the author's consulting clients.  It is in the
  public domain and therefore may be used by anybody for
  any purpose.

AUTHOR:

  Will Naylor

****************************************************************************/
#ifndef wnprmH
#define wnprmH


#define wn_permute_array(_result,_permutation,_array,_size)\
{\
  int _i,_size_copy;\
  \
  _size_copy = (_size);\
  \
  wn_assert((_result) != (_array));\
  wn_assert((int *)(_result) != (_permutation));\
  \
  for(_i=0;_i<_size_copy;_i++)\
  {\
    (_result)[_i] = (_array)[(_permutation)[_i]];\
  }\
}


void wn_random_permutation(int permutation[],int size);
void wn_identity_permutation(int permutation[],int size);
void wn_permute_permutation(int result[],int perm1[],int perm2[],int size);
void wn_invert_permutation(int inverse[],int permutation[],int size);
bool wn_is_valid_permutation(int permutation[],int size);


#endif

