/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this file is provided free of charge
  to the author's consulting clients.  It is in the
  public domain and therefore may be used by anybody for
  any purpose.

AUTHOR:

  Will Naylor

****************************************************************************/
#include <stdio.h>

#include <wn/wnlib.h>
#include <wn/wnasrt.h>

#include <wn/wnhtbl.h>



#if 1
main()
{
  wn_htab table;
  int i,j,num;
  bool success;

  printf("testing hash...\n");

  /*
  for(i=0;i<2000000;++i)
  {
    num = wn_inthash(i);
  }

  return;
  */

  wn_gpmake("no_free");

  wn_mkinthtab(&table);

  for(i=0;i<10000;++i)
  {
    success = wn_hins((ptr)(i+1),table,(ptr)i);
    wn_assert(success);
  }

  wn_hverify(table);

  /*
  for(j=0;j<50;++j)
  */
  for(i=0;i<10000;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(success);
  }

  wn_hverify(table);

  for(i=0;i<5000;++i)
  {
    success = wn_hdel(table,(ptr)i);
    wn_assert(success);
  }

  wn_hverify(table);

  for(i=0;i<5000;++i)
  {
    success = wn_hdel(table,(ptr)i);
    wn_assert(!(success));
  }

  wn_hverify(table);

  for(i=0;i<5000;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(!(success));
  }

  for(i=5000;i<10000;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(success);
    wn_assert(num == i+1);
  }

  for(i=2500;i<7500;++i)
  {
    success = wn_hfins((ptr)i,table,(ptr)i);
    wn_assert(success);
  }

  for(i=2500;i<7500;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(success);
    wn_assert(num == i);
  }

  for(i=0;i<2500;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(!(success));
  }

  for(i=7500;i<10000;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(success);
    wn_assert(num == i+1);
  }

  wn_hverify(table);

  for(i=2500;i<10000;++i)
  {
    success = wn_hdel(table,(ptr)i);
    wn_assert(success);
  }

  wn_hverify(table);

  for(i=0;i<10000;++i)
  {
    success = wn_hget((ptr *)&num,table,(ptr)i);
    wn_assert(!(success));
  }

  printf("  ok!!!!!!\n");

  exit(0);
}
#endif


