#include <stdio.h>
#include <math.h>

#include <wn/wnlib.h>
#include <wn/wnconj.h>
#include <wn/wnmem.h>

local double function(double x)
{
  double ret;

  ret = 1.0/x + x;

  printf("x = %20.20f,f = %20.20f\n",x,ret);

  return(ret);
}


/*
local double function(double x)
{
  double ret;

  ret = x-1.6666;

  if(ret > 0)
  {
    ret *= 20.0;
  }
  else
  {
    ret *= -1.0;
  }

  ret += 1.5555;

  printf("x = %20.20f,f = %20.20f\n",x,ret);

  return(ret);
}
*/


int main(void)
{
  double f0,f1,f2,x0,x1,x2;
  int code;

  wn_gpmake("no_free");

  x0 = 0.001;
  f0 = function(x0);

  x1 = 1.5;
  f1 = function(x1);

  x2 = 2.0;
  f2 = function(x2);

  wn_minimize_1d_raw(&code,
		     &f0,&f1,&f2,&x0,&x1,&x2,0.,
		     &function,100);

  printf("code = %d,f0=%f,f1=%f,f2=%f,x0=%f,x1=%f,x2=%f\n",
	 code,f0,f1,f2,x0,x1,x2);
  return 0;
}


